//******************************************************************************
//
//   ..........:	1wire_pic24.c
//
//   ()......:	 
//
//   ......:	 : 1-wire  PIC24
//
//   ........:	-
//
//   ..........:  -
//
//******************************************************************************             										  					

#include "1wire_pic24.h"	
							 							 
//    1-wire
unsigned char init_DS(void)																																   	 /*=14*/
{ 
	unsigned char check;
	
	DQ = 0;  																	// "0"  DQ	
	Delay_us(500);														// 500   
	DQ = 1;                              			// "1"  DQ
	Delay_us(70);															// 70   
	check = DQin;						    							// 
	Delay_us(223);														//    223
	
	return(check);  						   						
}                     											
						    
//   1-wire
unsigned char read_bit(void)
{	
	DQ=0;
	nop();nop();nop();nop();
	DQ=1;
	nop();nop();nop();nop();
		
	return(DQin);
}

//   1-wire
void write_bit(unsigned char b)
{	
	DQ = 0;
	if(b == 1) DQ = 1;																				
	Delay_us(133);				 // 133 
	DQ = 1;				 
}	

//     1-wire
void write_byte(unsigned char byte)  					   		 //<byte> -   
{ 
	unsigned char r, temp;    											 	 // 
	
	for (r = 0; r < 8; r++)    			     							 // 8   
	{ 
		temp=byte>>r;   							  								 // 
		temp &= 0x01;
		write_bit(temp);						
	}  																			  				 //   8 =30  
  Delay_us(106);																			// 106
  
}                      											 				


//   c  1-wire
unsigned char read_byte(void)   				   				 		// READ  1-wire=74*/
{ 
	unsigned char i;       							  							//  =75*/
	unsigned char d=0,s=0;
	
	for (i = 0; i < 8; i++)    									 				//  8 =78*/
	{ 
		s = read_bit()<<( i);
		d = d | s;
		Delay_us(136);				
	}
	
	return (d);      							     	
}                       							
																	
