//**************************************************************************************
//
//   ..........:	main.c
//
//   ()......:	Rubel
//
//   ()...:	PIC24F04KA201, Fosc=32=8(FRC)*4PLL;Fcy = 16. 
//																																			
//	 ....:	MPLAB C COMPILER FOR PIC24 MCUs AND dsPIC DSCs v3.23
//
//   ......:	  (PIC24KA201+DS18B20)
//
//   ........:	-
//
//   ..........:  -
//
//**************************************************************************************

#include <p24F04KA201.h>
//#include <timer.h>
#include "main.h"
#include "1wire_pic24.h"
//#include  <stdlib.h>
//#include 	<string.h>

//_CONFIG1(0x377F);
//_CONFIG2(0x799F);
_FGS( GCP_OFF & GWRP_OFF)															//  
_FOSCSEL(FNOSC_PRIPLL & IESO_OFF)											// ,    
//_FOSCSEL(FNOSC_FRCPLL & IESO_OFF)											//.   PLL,    
_FOSC(FCKSM_CSDCMD & OSCIOFNC_ON & POSCMOD_HS)				//OSCO -  ,  HS.
//_FOSC(FCKSM_CSDCMD & OSCIOFNC_ON & POSCMOD_NONE)			//,OSCO -  ,   . 																											

_FWDT(FWDTEN_OFF & WINDIS_OFF)
_FPOR(MCLRE_ON & PWRTEN_ON & BOREN_BOR0)
//_FICD(ICS_PGx2)
_FDS(DSWDTEN_OFF & DSWCKSEL_LPRC) 

/*******************************************************************************
*
*     :  main
*
*    	:  -
*
*     	:  -
*
*   	:     
*
************************************************************************/
int main (void)	/* =67*/
{				
	CLKDIVbits.RCDIV  = 0;		//   "0"(FRC=8M);
														//Fosc=8*4PLL=32; Fcy=Fosc/2=16;	
	
	//AD1PCFG = 0xFFFF;				//   
	portinit04KA201();				// 
	init_DS();								//  DSXXX
	timer1init();
	write_byte(0xCC);					// "skip ROM"
	write_byte(0x44);					// "  "
	IEC0bits.T1IE = 1;				//.    TMR1
	
	while (1)	
	{
		nop();
		//...
		//   -     TMR1(4),    
	}	 
}
																								 																	  
//  
void ind (unsigned char a)             						 
{ 	
	switch (a)      					 											//  "" -  
	{ 
		//  
		case 0:  LATB = ((PORTB&0xE000)|IND0); 				break; //  "0"
		case 1:  LATB = ((PORTB&0xE000)|IND1); 				break; //  "1"
		case 2:  LATB = ((PORTB&0xE000)|IND2); 				break; //  "2"
		case 3:  LATB = ((PORTB&0xE000)|IND3); 				break; //  "3"
		case 4:  LATB = ((PORTB&0xE000)|IND4); 				break; //  "4"
		case 5:  LATB = ((PORTB&0xE000)|IND5); 				break; //  "5"
		case 6:  LATB = ((PORTB&0xE000)|IND6); 				break; //  "6"
		case 7:  LATB = ((PORTB&0xE000)|IND7); 				break; //  "7"
		case 8:  LATB = ((PORTB&0xE000)|IND8); 				break; //  "8"
		case 9:  LATB = ((PORTB&0xE000)|IND9); 				break; //  "9"
 		case 10: LATB = ((PORTB&0xE000)|INDmin); 			break; //  " - " 
		case 11: LATB = ((PORTB&0xE000)|IND_H); 			break; //  "" 
		case 12: LATBbits.LATB12 = 0; break;								 //.  	
		case 13: LATBbits.LATB12 = 1; break;								 //. 
		case 14: LATB = ((PORTB&0xE000)|INDgr); 			break; // 
		case 15: LATB = ((PORTB&0xE000)|IND_OFF);			break; //
		default: nop();		
  }
}

//  1(4)
void __attribute__((interrupt,no_auto_psv)) _T1Interrupt(void)
{																		
	x++;																		//	
	//  HG1	
	if ((x)%4 == 0) 		 									 	
	{ 		
		w = (ack == 0) ? (tm/100):(11);  			// 1 =39
		HG12 = HG13 = HG14 = 0; 			 				//   2,3,4
		if(i) 																// .  "0",   "-" 
		{
			ind (10);
		}	
		else																	//     "0"
		{
			ind (w);	
			if (w == 0)     										//   c    100 =41
				ind (15);
		}		
		HG11 = 1;       			 								// HG1   U1=43			
		
		if(x == 4)           									//
		{	
			ack = init_DS();
			if(!ack)
			{
				write_byte(0xCC);										//c 
				write_byte(0x44);
			}	
		}
	} 																			
	
	//  HG1		
	if ((x)%4 == 1) 		   									
	{  	
		w = (ack == 0) ? ((tm%100)/10) :(11); //  
		HG11 = HG13 = HG14 = 0;								//   1,3,4
		ind(w);   		  		 									//   			
		if ((tm < 10) && (w != 11))     		 	//   10 
		{																			//  
			ind (15);														//  		
		}		
		HG12 = 1;       			 								// HG1   		
		
		if(x == 201)													// 																		
		{	
			init_DS();
			if(!ack)
			{
				write_byte(0xCC);         					//SKIP ROM			
				write_byte(0xBE);										//  		  
			}
		}
		if(x == 205)													// 
		{	
			for(k=0;k<2;k++)										//c 2  
			{
				mem[k] = read_byte();							
			}
		}		
	}

	//  HG1   
	if ((x)%4 == 2) 																					 
	{
		w = (ack == 0) ? (tm%10) : (11);  		// =39
		HG11 = HG12 = HG14 = 0;					  		//   1,2,4=40							
		ind (w);															// 	
		HG13 = 1;       											//  		
		
		if(x == 206)
		{
			u=0;		
			u = ((u+mem[1])<<8) + mem[0];				//     	
		}	
	}	

	//  HG1
	if ((x)%4 == 3) 	
	{	
		HG11 = HG12 = HG13 = 0;    				//   1,2,3=40				
		//if ((tm)%2 == 0) P1 = 0xFF; 		// 0,5 
		//else ind(5);										// 0,5
		if(!ack)
			ind(14); 													// 
		else
			ind(11);
		HG14 = 1;    											// 4 
		
	 	if(x == 207)	
		{
			if(mem[1] <= 7) 							 	//  
			{ 
				i = 0;
				if(u%16>=8) tm = (u>>4)+1;
				else tm = u>>4;
			}	
			else
			{
				i = 1;	 													//  .
				if((~(u-1))%16>=8) tm = ((~(u-1)) >> 4)+1;
				else tm = (~(u-1)) >> 4; 					// 
				if(tm==0) i = 0;
			}			
			x = 3;			
		}	
	}	
	IFS0bits.T1IF = 0;								 		//  
}

/************************************************************************
*
*     : timer1init
*
*    :  -
*
*     :  -
*
*   :    T1(62,5 )
*
************************************************************************/
void timer1init(void) 	
{	/* T1CON
	T1CONbits.TON   = 1;//15: 1 .
											//				"1" =  16- 1 <<( )  
											//				"0" =   16-bit 1
											//14: :   "0"											
	T1CONbits.TSIDL = 0;//13:     
											//				"1" =      
											//				"0" =        <<
											//12-7: :   "0"											
	T1CONbits.TGATE = 0;// 6:  "";if(TCS==1) ;if(TCS==0): 
											//			 "1" =    TGATE
											//			 "0" =   TGATE  <<
 	T1CONbits.TCKPS = 3;//5-4:    1
											//					"11hex" = "3dec" = 1:256; 											
											//					"10hex" = "2dec" = 1:64;
											//					"01hex" = "1dec" = 1:8;<< 
											//					"00hex" = "0dec" = 1:1;
											//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
											//: f[T1] = (Fosc/2)/8 = Fcy/8 = 16[]/8 = 2 ()
											//  : T=1/f[T1] = 1/2[]= 500[]
											//  :=500[]*65535=32 767,5[]=32,7675[]
											//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>										
											// 3: :   "0"
	T1CONbits.TSYNC = 0;// 2:    
											//			  TCS = 1: 
											//			 	"1" = c .
											//			 	"0" = c .<<
											//			  TCS = 0: 
											//				 
	T1CONbits.TCS	  = 0;//bit 1:    1
											//			 "1"=       T1CK( . ) 
											//			 "0"=    (FOSC/2)
											//bit 0: :   "0"	
	//*/										
	
	//   FEDCBA9876543210;	
	T1CON = 0b1000000000011000;   //., 62,5 
		
	PR1 = 8000; // 4 
	
	IFS0bits.T1IF = 0;						//  	
	//IEC0bits.T1IE = 1;						//. 	
	   
}						

/************************************************************************
*
*     : portinit04KA201
*
*    :  -
*
*     :  -
*
*   :    - PIC24F04KA200
*
************************************************************************/
void portinit04KA201(void) 
{	//A  =*********6543210=  *= 
	PORTA = 0b0000000000000000;  	//
	TRISA = 0b0000000001100000; 	//
  ODCA  = 0b0000000000000001;   // " ": RA6
	
	//  =FEDC**987**4*210=
	PORTB = 0b0000000000000000;		//
	TRISB = 0b1110000000000000; 	//
  //ODCB  = 0b0000000000000000;	  // " "	
}


		

  
